#include"blockpool.h"

int Blockpool::init(const char *filename,RAMS::RPointer_s& sud)
{
  int neu=gm.init(filename);
  if(neu)
  {
    gm.grow(as_);
    /* Hier wird die erste Seite ist die Informationsseite belegt */
    info = (ManagementInfo *)gm.begin();
    strcpy(info->info,"RAMS-Btree");
    info->freepagelist=0;
    info->unused_pages=PAGESIZE;
  }
  else
  {
    info = (ManagementInfo *)gm.begin();
  }
  sud.init(static_cast<off_t>(sizeof(ManagementInfo)),&gm);
  return neu;
}

void Blockpool::free(RAMS::RPointer<CommonPage,PAGESIZE>& page)
{
  CommonPage::init((char *)(page.ptr()),freepage);
  page.ptr()->next = info->freepagelist;
  info->freepagelist=page.offset();
}

void Blockpool::getpage(RAMS::RPointer<CommonPage,PAGESIZE> &ret)
{
 
  if(info->freepagelist == 0)
  {
    ret.setoff(info->unused_pages);
    info->unused_pages+=PAGESIZE;
    if(gm.length()<info->unused_pages) gm.grow(as_);
    return;
  }
  else
  {
    ret.setoff(info->freepagelist);
    info->freepagelist = ret.ptr()->next;
    return;
  }
}

#ifdef BLOCKPOOLTEST
#include<iostream.h>
Blockpool blockpool;

int main()
{
  RAMS::RPointer_s sud;
  blockpool.init("blockpool.mf",sud);
  RAMS::RPointer<CommonPage,PAGESIZE> akt(0,blockpool.getseg());
  for(int i=1;i<=10;i++)
  {
    blockpool.getpage(akt);
    cerr << akt.ptr() << " allokiert" << endl;
  }
  akt-=6;
  cerr << "Freigabe Page " << akt.ptr() << endl;
  blockpool.free(akt);
  akt+=2;
  cerr << "Freigabe Page " << akt.ptr() << endl;
  blockpool.free(akt);
}
#endif



