/** 
 * @file blockpool.h
 * @brief manages Blocks
 * @author<A href="http://www.infnet.verein.de/~rw/">Rudolf Weber</A> 2002
 */
#ifndef BLOCKPOOL_H
#define BLOCKPOOL_H
#include"growingpersistentmseg.h"
#include"rpointer.h"
#include"common_page.h"

/**
 * Layout of the first page for management
 * The Page is enhanced to PAGESIZE too
 */
struct ManagementInfo
{
  char info[80];
  off_t freepagelist;
  off_t unused_pages;
};

/**
 * @brief manages block / memorypages
 */
class Blockpool
{
protected:
  RAMS::PersistentGrowingMseg gm;
  ManagementInfo *info;
  int as_;
public:
  Blockpool():as_(256) { info=NULL; }
  Blockpool(const char *filename,int as=256):as_(as)
  {
    RAMS::RPointer_s sud;
    init(filename,sud);
  }
  /**
   * @param sud space user data (in the first page)
   */
  int init(const char *filename,RAMS::RPointer_s &sud); // return 1 if neu
  void free(RAMS::RPointer<CommonPage,PAGESIZE>& page);
  // ret mu schon fuer gm da sein !
  void getpage(RAMS::RPointer<CommonPage,PAGESIZE>& ret);
  RAMS::Mseg *getseg() { return &gm; }
};
#endif 









