#ifndef COMMONPAGE_H
#define COMMONPAGE_H
const int PAGESIZE=4096;
typedef unsigned long Page_type_t;

const Page_type_t freepage      = 0;
const Page_type_t leafPage     = 0xffff;
const Page_type_t indexpage     = 0x1111;
const Page_type_t blopbeginpage = 0xaaaa;

/**
 * \brief Common Things for all Pages
 * persistent layout
 */
struct CommonPage
{
  /// type of page;
  Page_type_t pagetyp;
  /// list
  off_t       prev;
  /// list
  off_t       next;

  /**
   * initializes a memorypage
   * @param m memorypage
   */
  static CommonPage *init(char *m,Page_type_t pt)
  {
    CommonPage *ret = (CommonPage *)m;
    ret->pagetyp=pt;
    ret->prev=0;
    ret->next=0;
    return NULL;
  }
};



#endif
