#include"indexpage.h"
#include<iostream.h>
#include<stdio.h>

Page_type_t  IndexPageAccess::pagetype() { return indexpage; }
size_t IndexPageAccess::space() { return 0; }

mempl_t IndexPageAccess::key(int i)
{
  mempl_t ret;
  ret.l = page()->keylen;
  ret.ptr = keyentry(i)->key;
  return ret;
}

int IndexPageAccess::keycmp(int i,const octet_t *other,size_t olen)
{
  octet_t *mykey = keyentry(i)->key;
  return memcmp(mykey,other,min(page()->keylen,olen));
}

void IndexPageAccess::init(uint16_t keylen)
{
  page()->pagetyp=indexpage;
  page()->parent=0;
  page()->anz=0;
  if(keylen%4 != 0)  // Alignment for Keyentry
  {
    page()->keylen = ((keylen/4)+1)*4;
    cerr << "IndexPageAccess::init: Korrektur keylen von " << keylen << " auf " <<  page()->keylen << endl;
  }
  else
  {
    page()->keylen=keylen;
  }
}


int IndexPageAccess::insert(const octet_t* key_,size_t keylen,off_t offset)
{
  int f=find(key_,keylen);
  if(count()==maxcount()-1) return -1; // voll
  if(f<count())
  {
    if(keycmp(f,key_,keylen)==0) return -2; // doppelt
    char *start = (char *)keyentry(f);
    char *ziel  = (char *)keyentry(f+1);
    size_t len = (count()-f)*sizeof_Keyentry();
    memmove(ziel,start,len);
  }
  page()->anz++;
  memset(keyentry(f)->key,'\0',page()->keylen);
  memcpy(keyentry(f)->key,key_,min(page()->keylen,keylen));
  keyentry(f)->offset = offset;

  return f;
}

int IndexPageAccess::replacelargestkey(const octet_t *key_,size_t keylen)
{
  int f = count()-1;
  memset(keyentry(f)->key,'\0',page()->keylen);
  memcpy(keyentry(f)->key,key_,min(page()->keylen,keylen));
  return f;
}

int IndexPageAccess::splitt(CommonPage *neu1,CommonPage *neu2)
{
  IndexPageAccess erste(neu1);
  IndexPageAccess zweite(neu2);
  erste.init(page()->keylen);
  zweite.init(page()->keylen);

  int g = count()/2;
  int i;
  for(i=0;i<g;i++)
  {
    mempl_t k = key(i);
    erste.insert(k.ptr,k.l,off(i));
  }
  for(i=g;i<count();i++)
  {
    mempl_t k = key(i);
    zweite.insert(k.ptr,k.l,off(i));
  }
  return 0;
}

#include<iostream.h>
#include"mempl_out.h"

char speicher[3*PAGESIZE];

void IndexPageAccess_dump(IndexPageAccess &ipac,ostream& str,char *base=0)
{
  str << "Anzahl Saetze " << ipac.count() << endl;
  for(int i=0;i<ipac.count();i++)
  {
    str << '>' << ipac.key(i) << "< (" << (void *)(base+ipac.off(i)) << ")" << endl;
  }
  str << endl;
}

#ifdef INDEXPAGETEST
int main(int argc,char **argv)
{
  RAMS::Mseg sv(speicher,3*PAGESIZE);
  RAMS::RPointer<CommonPage,PAGESIZE> base(0,&sv);
  IndexPageAccess ipac(base.ptr());
  ipac.init(10);
  cout << ipac.count() << " Schluessel von " << ipac.maxcount() << endl;

  char puffer[32];
  while(fgets(puffer,2048,stdin)!=0)
  {
    int len=strlen(puffer)-1;
    int r=ipac.insert((octet_t *)puffer,len,0);
    cout << r << endl;
    IndexPageAccess_dump(ipac,cout);
  }
  cout << "Teilen der Seite: " << endl;
  RAMS::RPointer<CommonPage,PAGESIZE> neu1(0,&sv);
  RAMS::RPointer<CommonPage,PAGESIZE> neu2(0,&sv);
  base+=1;
  neu1 = base;
  base+=1;
  neu2 = base;
    
  ipac.splitt(neu1.ptr(),neu2.ptr());
  IndexPageAccess erste(neu1.ptr());
  IndexPageAccess zweite(neu2.ptr());
  cout << "---------- Erste Seite --------------" << endl;
  IndexPageAccess_dump(erste,cout);
  cout << "---------- Zweite Seite -------------" << endl;
  IndexPageAccess_dump(zweite,cout); 
}
#endif

